//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "MailDlg.h"
#include "MBoxWin.h"
#include "NNameDlg.h"
#include "PicBoxDlg.h"
#include "FileMan.h"
#include "Global.h"
//---------------------------------------------------------------------------
#pragma link "OpenDlg"
#pragma resource "*.dfm"
TOMailboxForm *OMailboxForm;
//---------------------------------------------------------------------------
bool __fastcall OpenMailboxes()
{
   bool ok = false;
   TOMailboxForm *OMF = new TOMailboxForm(Application->MainForm);
   OMF->ShowModal();
   if (OMF->ModalResult==mrOk)
   {
      for (int i=0; i<OMF->ListBox->Items->Count; i++)
         if (OMF->ListBox->Selected[i])
         {
            OpenMailbox(OMF->ListBox->Items->Strings[i]);
            ok = true;
         }
   }
   delete OMF;
   return ok;
}
//---------------------------------------------------------------------------
__fastcall TOMailboxForm::TOMailboxForm(TComponent* Owner)
	: TOpenForm(Owner)
{
   mode = "Open ";
   LookInBox->Items->Add(UserMailboxes);
   LookInBox->ItemIndex = 0;
   LoadItems();
   if (ListBox->Items->IndexOf("outbox")<0)
      ListBox->Items->Add("outbox");
}
//---------------------------------------------------------------------------
void __fastcall TOMailboxForm::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   if (ModalResult==mrCancel) return;

   if (Name->Text.IsEmpty() && ListBox->SelCount==0) {
      MyBeep(MB_OK); CanClose = false;
      return;
   }
}
//---------------------------------------------------------------------------
void __fastcall TOMailboxForm::PopupMenuPopup(TObject *Sender)
{
   int c=0;
   for (int i=0; i<ListBox->Items->Count; i++)
      if (ListBox->Selected[i]) c++;
   PopDeleteItems->Enabled = c > 0;
   PopRenameItem->Enabled = c==1;
   PopOpenItem->Enabled = c > 0;
}
//---------------------------------------------------------------------------
void __fastcall TOMailboxForm::PopNewItemClick(TObject *Sender)
{
   AnsiString boxname;
   if ((boxname=CreateMailbox())!="")
   {
      OpenMailbox(boxname);
      //Close();
   }
}
//---------------------------------------------------------------------------
void __fastcall TOMailboxForm::PopOpenItemClick(TObject *Sender)
{
   for (long i=0; i<ListBox->Items->Count; i++)
      if (ListBox->Selected[i])
         OpenMailbox(ListBox->Items->Strings[i]);
   Close();
}
//---------------------------------------------------------------------------
void __fastcall TOMailboxForm::PopDeleteItemsClick(TObject *Sender)
{
   if (LookInBox->Text==UserMailboxes)
   {
      AnsiString pl = ListBox->SelCount>1 ? "es":"";
      if (MsgBoxHwnd(Handle,"Delete selected mailbox"+pl+" and contents!\n\nAre you sure?",
             "Delete Mailbox",MB_OKCANCEL)==IDOK &&
          MsgBoxHwnd(Handle,"Mail in deleted mailbox"+pl+" will be lost forever!",
             "Delete Mailbox",MB_OKCANCEL)==IDOK)
      {
         long i=0; while (i<ListBox->Items->Count)
         {
            if (ListBox->Selected[i])
            {
               AnsiString boxname = ListBox->Items->Strings[i];
               if ((MailboxWin=FindOpenMailbox(boxname))!=NULL)
                  MailboxWin->Close();
               Cursor = crHourGlass;
               DelMailboxPos(boxname);
               DelMailbox(boxname);
               DelMenubox(boxname);
               ListBox->Items->Delete(i);
               Cursor = crDefault;
            }
            else i++;
         }
      }
   }
}
//---------------------------------------------------------------------------
void __fastcall TOMailboxForm::PopRenameItemClick(TObject *Sender)
{
   AnsiString Newname,Oldname;
   for (int i=0; i<ListBox->Items->Count; i++) // find the single selected name
   {
      if (ListBox->Selected[i])
      {
         Oldname = ListBox->Items->Strings[i];
         break;
      }
   }
   if (Oldname.IsEmpty()) return;
   if ((Newname=GetNewItemName(Oldname,"Rename Mailbox : "+Oldname,UserMailboxes))!="")
   {
      if (Newname==Oldname || Newname.IsEmpty()) return;
      Cursor = crHourGlass;
      RenameAppIndex(UserMailboxes+PS+Oldname,Newname);
      if (DelMenubox(Oldname)) AddMenubox(Newname);
      SetMailboxPos(Newname,0);
      DelMailboxPos(Oldname);
      
      GetAppData(ListBox->Items,UserMailboxes);
      for (int i=0; i<ListBox->Items->Count; i++)
         if (ListBox->Items->Strings[i]==Newname)
         {
            ListBox->Selected[i] = true;
            ListBox->ItemIndex = i;
            break;
         }
      Cursor = crDefault;
   }
}
//---------------------------------------------------------------------------
void __fastcall TOMailboxForm::ListBoxClick(TObject *Sender)
{
   TOpenForm::ListBoxClick(Sender);
   DelBoxBtn->Enabled = ListBox->SelCount>0;  
}
//---------------------------------------------------------------------------
